<link rel="preconnect" href="https://fonts.googleapis.com">
<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
<link href="https://fonts.googleapis.com/css2?family=Nunito:wght@200;300;400;600&display=swap" rel="stylesheet">

<style>
body {
	margin-top: 50px;
	font-family: 'Nunito', sans-serif;
}

table {
	width: 350px;
}
</style>

<?php
// Initialize cURL and make the request
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, 'https://grantcardone.api.hasoffers.com/Apiv3/json?NetworkToken=NET5jO42kWQIB3QnoZPSVRTdXsWFo9&Target=Report&Method=getStats&fields[]=Stat.revenue&fields[]=Affiliate.company&sort[Stat.revenue]=desc&limit=10');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($ch);
curl_close($ch);

// Decode the response into a PHP associative array
$response = json_decode($response, true);

// Make sure that there wasn't a problem decoding the repsonse
if(json_last_error()!==JSON_ERROR_NONE){
	throw new RuntimeException(
		'API response not well-formed (json error code: '.json_last_error().')'
	);
}

// Print out the response details or, any error messages
if(isset($response['response']['status']) && $response['response']['status']===1){
	
	echo "<b>Top 10 Affiliates:</b><br><br>";
	echo "<table>";
	echo "<tr><td>Ranking</td><td>Company</td><td>Revenue</td></tr>";
	
	foreach($response['response']['data']['data'] as $key => $value) {

		$ranking = $key+1;
		$company = $response['response']['data']['data'][$key]['Affiliate']['company'];
		$revenue = $response['response']['data']['data'][$key]['Stat']['revenue'];
		$revenue_pretty = "$".number_format($revenue);

		echo "<tr><td>".$ranking."</td><td>".$company."</td><td>".$revenue_pretty."</td></tr>";


		echo PHP_EOL;
	}

echo "</table>";
}

else {
	echo 'API call failed'.(isset($response['response']['errorMessage'])?' ('.$response['response']['errorMessage'].')':'').'';
	echo PHP_EOL;
	echo 'Errors: <pre>'.print_r($response['response']['errors'], true).'';
	echo PHP_EOL;
}
?>