<?php

// Set your API endpoint
$apiEndpoint = 'https://secure.easypaydirectgateway.com/api/query.php';

// Set your security key
$securityKey = 'ZEuDMmWd6t47cjNPd5WwhQ8EMmNzXxp2';

// Set your secret for X-Hub-Signature
$webhookSecret = 'yourSecret1234';

// Set other parameters
$startDate = date('Ymd', strtotime('-10 day'));
$resultLimit = 100;
$condition = 'complete';

// Initialize cURL session
$ch = curl_init($apiEndpoint);

// Initialize page number
$pageNumber = 0;

do {
    // Set data for POST request
    $data = [
        'security_key' => $securityKey,
        'start_date' => $startDate,
        'result_limit' => $resultLimit,
        'condition' => $condition,
        'page_number' => $pageNumber,
    ];

    // Set cURL options
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));

    // Execute cURL session
    $responseXml = curl_exec($ch);

    // Check for cURL errors
    if (curl_errno($ch)) {
        echo 'Curl error: ' . curl_error($ch);
        break; // Exit the loop on error
    }

    // Convert XML to SimpleXMLElement
    $responseXml = simplexml_load_string($responseXml);

    // Extract and process transactions in a loop
    foreach ($responseXml->transaction as $transaction) {
        // Convert each transaction to simplified JSON
        $output = [
            "transaction_id" => (string)$transaction->transaction_id,
            "order_description" => (string)$transaction->order_description,
            "email" => (string)$transaction->email,
            "amount" => (string)$transaction->action->amount,
            "date" => (string)$transaction->action->date,
            "action_type" => (string)$transaction->action->action_type,
        ];

        $simplifiedJson = json_encode($output, JSON_PRETTY_PRINT);

        // Send the data to the external webhook link
        $webhookUrl = 'https://grantcardone.domo.com/api/iot/v1/webhook/data/...'; // Replace with your Domo webhook URL

        $chWebhook = curl_init($webhookUrl);

        // Compute SHA1 hash with secret
        $sha1Hash = hash_hmac('sha1', $simplifiedJson, $webhookSecret);

        // Add X-Hub-Signature header
        $webhookHeaders = [
            'Content-Type: application/json',
            'X-Hub-Signature: sha1=' . $sha1Hash,
        ];

        // Set additional cURL options for headers
        curl_setopt($chWebhook, CURLOPT_POST, 1);
        curl_setopt($chWebhook, CURLOPT_POSTFIELDS, $simplifiedJson);
        curl_setopt($chWebhook, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($chWebhook, CURLOPT_HTTPHEADER, $webhookHeaders);

        // Execute cURL session for webhook
        $webhookResponse = curl_exec($chWebhook);

        // Check for cURL errors
        if (curl_errno($chWebhook)) {
            echo 'Curl error for webhook: ' . curl_error($chWebhook);
        } else {
            // Display webhook response
            echo 'Webhook Response: ' . $webhookResponse;
        }

        // Close cURL session for webhook
        curl_close($chWebhook);
    }

    // Increment page number for the next request
    $pageNumber++;

} while (!empty($responseXml->transaction));

// Close cURL session for the main API request
curl_close($ch);
?>
