<?php


// Your HubSpot API access token
$accessToken = 'pat-na1-146939c6-fcab-44f8-bb9c-8b77cd12ea54';

// HubSpot API endpoint for getting all meetings
$getMeetingsApiUrl = 'https://api.hubapi.com/crm/v3/objects/meetings';

// Parameters for sorting and limiting the results
$parameters = [
    'limit' => 5,  // Adjust the limit as needed
    'sort' => 'createdAt DESC',
];

// Append parameters to the URL
$getMeetingsApiUrl .= '?' . http_build_query($parameters);

// Configure and execute the get meetings request
$ch = curl_init($getMeetingsApiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $accessToken,
]);

$getMeetingsResponse = curl_exec($ch);
$getMeetingsError = curl_error($ch);

// Log the get meetings response
error_log('Get meetings response: ' . $getMeetingsResponse, 3, 'api_log.txt');

curl_close($ch);

if ($getMeetingsResponse === false) {
    error_log('Error executing get meetings request: ' . $getMeetingsError, 3, 'api_log.txt');
} else {
    // Attempt to decode the response
    $meetingsData = json_decode($getMeetingsResponse, true);

    if (json_last_error() == JSON_ERROR_NONE) {
        // Check if the response indicates an error
        if (isset($meetingsData['status']) && $meetingsData['status'] === 'error') {
            // Log and handle the error if needed
            error_log('Error getting meetings: ' . $meetingsData['message'], 3, 'api_log.txt');
        } else {
            // Access the latest meetings data here (e.g., $meetingsData['results'])
            echo 'Latest meetings retrieved successfully.';
            print_r($meetingsData); // Print meetings data for testing
        }
    } else {
        // Log an error if decoding fails
        error_log('Error decoding get meetings response JSON.', 3, 'api_log.txt');
    }
}
?>
