
<?php





// Your HubSpot API access token
$accessToken = 'pat-na1-146939c6-fcab-44f8-bb9c-8b77cd12ea54';

// Your meeting ID to update
$meetingId = '6381627';

// HubSpot API endpoint for updating meetings
$updateMeetingApiUrl = 'https://api.hubapi.com/crm/v3/objects/meetings/' . $meetingId;

// Your updated start and end dates
$newStartDate = '2023-12-12T09:00:00Z';
$newEndDate = '2024-12-12T10:00:00Z';

// Payload data for updating the meeting
$updateMeetingData = [
    'properties' => [
        [
            'name' => 'start',
            'value' => $newStartDate,
        ],
        [
            'name' => 'end',
            'value' => $newEndDate,
        ],
    ],
];

// Convert update data to JSON
$updateMeetingDataJson = json_encode(['properties' => $updateMeetingData['properties']]);

// Log the update request and payload
error_log('Executing update meeting request. Payload: ' . $updateMeetingDataJson, 3, 'api_log.txt');

// Configure and execute the update meeting request with the adjusted payload
$ch = curl_init($updateMeetingApiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
curl_setopt($ch, CURLOPT_POSTFIELDS, $updateMeetingDataJson);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $accessToken,
]);

$updateMeetingResponse = curl_exec($ch);
$updateMeetingError = curl_error($ch);

// Log the update meeting response
error_log('Update meeting response: ' . $updateMeetingResponse, 3, 'api_log.txt');

curl_close($ch);

if ($updateMeetingResponse === false) {
    error_log('Error executing update meeting request: ' . $updateMeetingError, 3, 'api_log.txt');
} else {
    // Attempt to decode the response
    $updateMeetingResult = json_decode($updateMeetingResponse, true);

    if (json_last_error() == JSON_ERROR_NONE) {
        // Check if the response indicates an error
        if (isset($updateMeetingResult['status']) && $updateMeetingResult['status'] === 'error') {
            // Log and handle the error if needed
            error_log('Error updating meeting: ' . $updateMeetingResult['message'], 3, 'api_log.txt');
        } else {
            echo 'Meeting updated successfully.';
        }
    } else {
        // Log an error if decoding fails
        error_log('Error decoding update meeting response JSON.', 3, 'api_log.txt');
    }
}
?>
