<?php

header("Access-Control-Allow-Origin: *");

// API endpoint
$url = 'https://app.aloware.com/api/v1/webhook/lookup';

// Get the phone number dynamically from the URL
$phone_number = isset($_GET['phone_number']) ? $_GET['phone_number'] : '';

// Check if the phone number is provided
if (empty($phone_number)) {
    echo json_encode(['error' => 'Phone number is missing in the URL']);
    exit;
}

// Data to be sent in the POST request
$data = [
    'api_token' => 'F3B3F28D',
    'phone_number' => $phone_number,
];

// Initialize cURL session
$ch = curl_init($url);

// Set cURL options
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Accept: application/json',
]);

// Execute cURL session
$response = curl_exec($ch);

// Check for errors
if (curl_errno($ch)) {
    echo json_encode(['error' => 'Curl error: ' . curl_error($ch)]);
} else {
    // Print the response
    echo $response;
}

// Close cURL session
curl_close($ch);

?>
