<?php
header('Access-Control-Allow-Origin: *');

if (isset($_GET['timezone'])) {
    $timezone = $_GET['timezone'];
    
    if ($timezone === "GMT") {
        $timezone = "GMT+0";
    }

    $url = 'https://api.webinarjam.com/everwebinar/webinar';
    $data = [
        'api_key' => '8f4af42b-4463-49ac-8e72-e4108dfa6944',
        'webinar_id' => "34",
        'timezone' => $timezone
    ];

    $options = [
        'http' => [
            'header' => "Content-type: application/x-www-form-urlencoded\r\n",
            'method' => 'POST',
            'content' => http_build_query($data)
        ]
    ];

    $context = stream_context_create($options);
    $result = @file_get_contents($url, false, $context);

    if ($result === FALSE) {
        echo "API Error.";
        exit;
    }

    $jsonRes = json_decode($result, true);
    
    $output = '';
    $firstRadio = true;
    foreach ($jsonRes['webinar']['schedules'] as $schedule) {
        $schedule_value = $schedule['schedule'];
        $date_value = $schedule['date'];
        
        // Convert date to a more readable format
        $date = new DateTime($date_value, new DateTimeZone($jsonRes['webinar']['timezone']));
        $pretty_date = $date->format('g:i A');

        // Calculate the difference in days
        $today = new DateTime('now', new DateTimeZone($timezone));
        $diff = $today->diff($date)->days;

        // Adjust the displayed day
        $day_display = ($diff == 0) ? 'Today' : (($diff == 1) ? 'Tomorrow' : '');

        // Generate radio options
        if ($firstRadio) {
            // Append blank span to the first radio label
            $output .= "<label><input type='radio' name='schedule' value='$schedule_value' date='$date_value'>$day_display at $pretty_date<span></span></label><br>";
            $firstRadio = false;
        } else {
            $output .= "<label><input type='radio' name='schedule' value='$schedule_value' date='$date_value'>$day_display at $pretty_date</label><br>";
        }
    }
    
    echo $output;
}
?>
