<?php

// Your HubSpot API access token
$accessToken = 'pat-na1-468fe988-4669-487f-8c8c-a9d121fdb3a2';

// Your list ID stored in a variable
$list_id = '14584';

// HubSpot API endpoint for searching contacts
$searchApiUrl = 'https://api.hubapi.com/crm/v3/objects/contacts/search';

// HubSpot API endpoint for creating and updating contacts
$contactsApiUrl = 'https://api.hubapi.com/crm/v3/objects/contacts';

// HubSpot API endpoint for adding contacts to a list
$addToListApiUrl = 'https://api.hubapi.com/contacts/v1/lists/' . $list_id . '/add';

// Your payload data
$searchData = array(
    'filterGroups' => array(
        array(
            'filters' => array(
                array(
                    'value' => $email,
                    'propertyName' => 'email',
                    'operator' => 'EQ',
                ),
            ),
        ),
    ),
);

$json = json_encode($searchData);

// Log the search request and payload
error_log('Executing search request. Payload: ' . $json, 3, 'api_log.txt');

// Configure and execute the search request
$searchHeaders = array(
    'Content-Type: application/json',
    'Authorization: Bearer ' . $accessToken,
);

$ch = curl_init($searchApiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

$searchResponse = curl_exec($ch);
$searchError = curl_error($ch);

// Log the search response
error_log('Search response: ' . $searchResponse, 3, 'api_log.txt');

curl_close($ch);

if ($searchResponse === false) {
    error_log('Error executing search request: ' . $searchError, 3, 'api_log.txt');
}

$searchResult = json_decode($searchResponse, true);

if (isset($searchResult['total']) && $searchResult['total'] > 0) {
    // Contact found, update the existing contact
    $contactId = $searchResult['results'][0]['id'];

    // Prepare the update request data with all properties under 'properties'
    $updateData = array(
        "properties" => array(
            "email" => $email,
            "firstname" => $firstname,
            "lastname" => $lastname,
            // Only update phone if the condition is met
            "phone" => (isset($phone) && strlen($phone) > 5) ? $phone_code . $phone : null,
            "n10xmp__sms_consent" => $consent,
            "n_10xmp_session_datetime" => $formattedDate,
            "n10xms__live_link" => $live_param
        )
    );

    // Convert update data to JSON
    $updateDataJson = json_encode($updateData);

    // Log the update request and payload
    error_log('Executing update request. Payload: ' . $updateDataJson, 3, 'api_log.txt');

    // Configure and execute the update request with the adjusted payload
    $ch = curl_init($contactsApiUrl . '/' . $contactId);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $updateDataJson);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

    $updateResponse = curl_exec($ch);
    $updateError = curl_error($ch);

    // Log the update response
    error_log('Update response: ' . $updateResponse, 3, 'api_log.txt');

    curl_close($ch);

    if ($updateResponse === false) {
        error_log('Error executing update request: ' . $updateError, 3, 'api_log.txt');
    }

    //  echo 'Contact updated successfully.';
} else {
    // Contact not found, create a new contact

    // Prepare the create request data with all properties under 'properties'
    $newContactData = array(
        "properties" => array(
            "email" => $email,
            "firstname" => $firstname,
            "lastname" => $lastname,
            // Only include phone if the condition is met
            "phone" => (isset($phone) && strlen($phone) > 5) ? $phone_code . $phone : null,
            "n10xmp__sms_consent" => $consent,
            "n_10xmp_session_datetime" => $formattedDate
        )
    );

    // Convert new contact data to JSON
    $newContactDataJson = json_encode($newContactData);

    // Log the create request and payload
    error_log('Executing create request. Payload: ' . $newContactDataJson, 3, 'api_log.txt');

    // Configure and execute the create request with the adjusted payload
    $ch = curl_init($contactsApiUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $newContactDataJson);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

    $createResponse = curl_exec($ch);
    $createError = curl_error($ch);

    // Log the create response
    error_log('Create response: ' . $createResponse, 3, 'api_log.txt');

    curl_close($ch);

    if ($createResponse === false) {
        error_log('Error executing create request: ' . $createError, 3, 'api_log.txt');
    }

    // Add the contact to the list
    $listJson = json_encode(
        array(
            "emails" => array($email)
        )
    );

    // Log the add to list request and payload
    error_log('Adding contact to the list. Payload: ' . $listJson, 3, 'api_log.txt');

    $ch = curl_init();
    curl_setopt_array($ch, array(
        CURLOPT_URL => $addToListApiUrl,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => $listJson,
        CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer ' . $accessToken,
            'Content-Type: application/json'
        ),
    ));

    $addToListResponse = curl_exec($ch);
    $addToListError = curl_error($ch);

    // Log the add to list response
    error_log('Add to list response: ' . $addToListResponse, 3, 'api_log.txt');

    curl_close($ch);

    if ($addToListResponse === false) {
        error_log('Error adding contact to the list: ' . $addToListError, 3, 'api_log.txt');
    }

    //  echo 'New contact created and added to the list successfully.';
}
?>
