<?php

// Check if schedule_id is empty and set it to 123 as a fallback
if (empty($_POST['schedule_id'])) {
    $_POST['schedule_id'] = "134"; // JIT Session for 10XMP
}

// Initialize an array to store errors and post parameters
$errors = array();
$post_params = $_POST;

$name = $_POST['name'] ?? null;

if (!$name) {
    $errors[] = "Name is empty";
} else {
    $nameparts = explode(" ", $name);

    // Check if index 1 exists in the array before accessing it
    $firstname = $nameparts[0] ?? '';
    $lastname = isset($nameparts[1]) ? $nameparts[1] : ''; // Check if index 1 exists
}

$email = $_POST['email'] ?? null;
if (!$email) {
    $errors[] = "Email is empty";
}

$phone = $_POST['phone'] ?? '';
$phone_code = $_POST['phone_code'] ?? '';
$full_phone = $phone_code . $phone;
$schedule_id = $_POST['schedule_id'] ?? '';
$date = $_POST['date'] ?? '';
$timezone = $_POST['timezone'] ?? '';
$consent = $_POST['consent'] ?? '';

$timezone = str_replace(' ', '', $timezone);

if ($timezone == "GMT") {
    $timezone = "GMT+0";
}

if ($phone == "") {
    $phone_code = "";
}

// Check for errors before making the API call
if (!empty($errors)) {
    // Save the errors and post parameters to a log file or database
    $error_log = fopen('error_log.txt', 'a');
    fwrite($error_log, "[" . date('Y-m-d H:i:s') . "] " . implode("\n", $errors) . "\n");
    fclose($error_log);

    // Display an error message to the user or redirect them to an error page
    echo "Error";
    exit;
}

$url = 'https://api.webinarjam.com/everwebinar/register';

// Include consent in the data array
$data = array(
    'api_key' => '8f4af42b-4463-49ac-8e72-e4108dfa6944',
    'webinar_id' => "74",
    'first_name' => $firstname,
    'last_name' => $lastname,
    'email' => $email,
    'phone' => $phone,
    'phone_country_code' => $phone_code,
    'schedule' => $schedule_id,
    'date' => $date,
    'timezone' => $timezone
);

$options = array(
    'http' => array(
        'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
        'method'  => 'POST',
        'content' => http_build_query($data)
    )
);

$context  = stream_context_create($options);
$result = file_get_contents($url, false, $context);

if ($result === FALSE) {
    // Save the post parameters to a log file or database
    $error_log = fopen('error_log.txt', 'a');
    fwrite($error_log, "[" . date('Y-m-d H:i:s') . "] Failed API call: " . print_r($post_params, true) . "\n");
    fclose($error_log);

    echo "Error";
    exit;
} else {
    $json = json_decode($result, true);

    $live_param = $json['user']['live_room_url'];
    $countdown = $json['user']['date'];
    $date2 = $json['user']['date'];
    $timezone2 = $json['user']['timezone'];
    $dateTime = new DateTime($date2, new DateTimeZone($timezone2));
    $formattedDate = $dateTime->getTimestamp() * 1000;

    $redirect = "https://10xworkshop.com/webinar-waiting-room-3?join=" . $live_param . "&cd=" . $countdown;

    include('hubspot.php');
}

header('Location: ' . $redirect);
?>
