<?php
header('Access-Control-Allow-Origin: *');

if (isset($_GET['timezone'])) {
    $timezone = $_GET['timezone'];
    
    if ($timezone === "GMT") {
        $timezone = "GMT+0";
    }

    $url = 'https://api.webinarjam.com/everwebinar/webinar';
    $data = [
        'api_key' => '8f4af42b-4463-49ac-8e72-e4108dfa6944',
        'webinar_id' => "61",
        'timezone' => $timezone
    ];

    $options = [
        'http' => [
            'header' => "Content-type: application/x-www-form-urlencoded\r\n",
            'method' => 'POST',
            'content' => http_build_query($data)
        ]
    ];

    $context = stream_context_create($options);
    $result = @file_get_contents($url, false, $context);

    if ($result === FALSE) {
        echo "API Error.";
        exit;
    }

    $jsonRes = json_decode($result, true);
    
    $output = [];
    foreach ($jsonRes['webinar']['schedules'] as $schedule) {
        $schedule_value = $schedule['schedule'];
        $date_value = $schedule['date'];
        
        // Convert date to a more readable format
        $date = new DateTime($date_value);
        $pretty_date = $date->format('l, j M g:i A');
        
        $output[] = "<option value='$schedule_value' custom_date_text='$date_value'>$pretty_date</option>";
    }
    
    echo implode('', $output);
}
?>
