<?php

// Your HubSpot API access token
$accessToken = 'pat-na1-468fe988-4669-487f-8c8c-a9d121fdb3a2';

// Your list ID stored in a variable
$list_id = '14584';

// HubSpot API endpoint for searching contacts
$searchApiUrl = 'https://api.hubapi.com/crm/v3/objects/contacts/search';

// HubSpot API endpoint for creating and updating contacts
$contactsApiUrl = 'https://api.hubapi.com/crm/v3/objects/contacts';

// HubSpot API endpoint for adding contacts to a list
$addToListApiUrl = 'https://api.hubapi.com/contacts/v1/lists/' . $list_id . '/add';

// Adjusted payload format for search (email only)
$searchData = array(
    'filterGroups' => array(
        array(
            'filters' => array(
                array(
                    'value' => $email,
                    'propertyName' => 'email',
                    'operator' => 'EQ',
                ),
            ),
        ),
    ),
);

$json = json_encode($searchData);

// Configure and execute the search request
$searchHeaders = array(
    'Content-Type: application/json',
    'Authorization: Bearer ' . $accessToken,
);

$ch = curl_init($searchApiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

$searchResponse = curl_exec($ch);
curl_close($ch);

if ($searchResponse === false) {
//  die('Error executing search request: ' . curl_error($ch));
}

$searchResult = json_decode($searchResponse, true);

if (isset($searchResult['total']) && $searchResult['total'] > 0) {
    // Contact found, update the existing contact
    $contactId = $searchResult['results'][0]['id'];

    // Prepare the update request data with all properties under 'properties'
    $updateData = array(
        "properties" => array(
            "email" => $email,
            "firstname" => $firstname,
            "lastname" => $lastname,
            "phone" => $phone_code . $phone,
            "n10xmp__sms_consent" => $consent
        )
    );

    // Convert update data to JSON
    $updateDataJson = json_encode($updateData);

    // Configure and execute the update request with the adjusted payload
    $ch = curl_init($contactsApiUrl . '/' . $contactId);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $updateDataJson);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

    $updateResponse = curl_exec($ch);
    curl_close($ch);

    if ($updateResponse === false) {
//      die('Error executing update request: ' . curl_error($ch));
    }

//  echo 'Contact updated successfully.';
} else {
    // Contact not found, create a new contact

    // Prepare the create request data with all properties under 'properties'
    $newContactData = array(
        "properties" => array(
            "email" => $email,
            "firstname" => $firstname,
            "lastname" => $lastname,
            "phone" => $phone_code . $phone,
            "n10xmp__sms_consent" => $consent
        )
    );

    // Convert new contact data to JSON
    $newContactDataJson = json_encode($newContactData);

    // Configure and execute the create request with the adjusted payload
    $ch = curl_init($contactsApiUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $newContactDataJson);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $searchHeaders);

    $createResponse = curl_exec($ch);
    curl_close($ch);

    if ($createResponse === false) {
//      die('Error executing create request: ' . curl_error($ch));
    }

    // Add the contact to the list
    $listJson = json_encode(
        array(
            "emails" => array($email)
        )
    );

    $ch = curl_init();
    curl_setopt_array($ch, array(
        CURLOPT_URL => $addToListApiUrl,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => $listJson,
        CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer ' . $accessToken,
            'Content-Type: application/json'
        ),
    ));

    $addToListResponse = curl_exec($ch);
    curl_close($ch);

    if ($addToListResponse === false) {
//      die('Error adding contact to the list: ' . curl_error($ch));
    }

//  echo 'New contact created and added to the list successfully.';
}
?>
