<?php
header('Access-Control-Allow-Origin: *');

$curl = curl_init();

curl_setopt_array($curl, array(
    CURLOPT_URL => 'https://api.webinarfuel.com/webinars/13897?exact_recurring_dates=true&sessions_limit=3&time_zone=GMT',
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => array(
        'Authorization: Bearer cXJHxqsWDw4nSPm4RwAgiXCi'
    ),
));

$response = curl_exec($curl);
curl_close($curl);

// Decode the JSON response to an associative array
$jsonRes = json_decode($response, true);

// Initialize an empty array to hold the output options
$output = [];

// Check if the response contains the webinar sessions
if (isset($jsonRes['webinar']['sessions'])) {
    foreach ($jsonRes['webinar']['sessions'] as $session) {
        $scheduled_at = $session['id'];
        $formatted_scheduled_at = $session['formatted_scheduled_at'];
        
        // Trim the formatted scheduled time to AM/PM format
        $trim = preg_replace('/(AM|PM).*/', '$1', $formatted_scheduled_at);

        // Append the formatted option element to the output array
        $output[] = "<option value='$scheduled_at' custom_date_text='$formatted_scheduled_at'>$trim</option>";
    }
}

// Display the output options
foreach ($output as $option) {
    echo $option;
}

?>

